/*
   The program "calls" Adder.class as an external process.
   This is a baby example of parallel programming, or a very
   simplified example of how a "remote procedure call" might work.
*/
import java.util.Scanner;
import java.io.*;
import java.util.List;
import java.util.ArrayList;

public class UseAdder
{
   public static void main(String[] args) throws IOException, InterruptedException
   {
      // Create a ProcessBuilder object for running Adder.class
      List<String> childArgs = new ArrayList<String>();
      childArgs.add("java");
      childArgs.add("Adder");
      // Put command-line arguments of this process on the command-line of the child process.
      for (int i = 0; i < args.length; i++)
         childArgs.add(args[i]);
      ProcessBuilder pb = new ProcessBuilder( childArgs );

      // "call" Adder
      Process p = pb.start();
      // wait for the "call" to return
      p.waitFor();

      // Read the result from the Adder process's standard output.
      // Create a new stream to read data from the output of the Adder process.
      Scanner scanner = new Scanner( p.getInputStream() );
      int result = scanner.nextInt();

      // write the result to stdout
      System.out.println( result );
   }
}